package com.qq245949795.luckeregg;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
 
/**
 * ͬʳ齱߰
 *
 * @author Shunli
 */
public class LotteryUtil {
    /**
     * 齱
     *
     * @param orignalRates
     *            ԭʼĸб֤˳ʵƷӦ
     * @return
     *         Ʒ
     */
    public static int lottery(List<Gift> gifts) {
    	
    	List<Double> orignalRates=new ArrayList<Double>();
    	
        for (Gift gift : gifts) {
            double probability = gift.probability;
            if (probability < 0) {
                probability = 0;
            }
            orignalRates.add(probability);
        }

        if (orignalRates == null || orignalRates.isEmpty()) {
            return -1;
        }
 
        int size = orignalRates.size();
 
        // ܸʣԱ֤һܸ1
        double sumRate = 0d;
        for (double rate : orignalRates) {
            sumRate += rate;
        }
 
        // ÿƷܸʵĻµĸ
        List<Double> sortOrignalRates = new ArrayList<Double>(size);
        Double tempSumRate = 0d;
        for (double rate : orignalRates) {
            tempSumRate += rate;
            sortOrignalRates.add(tempSumRate / sumRate);
        }
 
        // ֵȡȡƷ
        double nextDouble = Math.random();
        sortOrignalRates.add(nextDouble);
        Collections.sort(sortOrignalRates);
 
        return sortOrignalRates.indexOf(nextDouble);
    }
}