package com.qq245949795.luckeregg;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;



public class Luck extends JavaPlugin
{
	private static Luck instance;
	public static List<Gift> giftsa=new ArrayList<Gift>();
	public static List<Gift> giftsb=new ArrayList<Gift>();
	public static List<Gift> giftsc=new ArrayList<Gift>();
	static FileConfiguration config;
	public static ItemStack[] breaktool=new ItemStack[3];
	
	public static Luck getInstance() {
		return instance;  
	}
	
	public void onEnable()
	{
		instance=this;
		getCommand("luckeregg").setExecutor(new CmdExecutor());
		getServer().getPluginManager().registerEvents(new EventListeners(), this);
		load();
	}

	public void load() {
		saveDefaultConfig();
		reloadConfig();
		config=getConfig();
		GUI.spawnInvItems(config.getConfigurationSection("Items"));
		giftsa.clear();
		Gift.addGiftList(config.getConfigurationSection("LuckerEggs.ƷϺ"), giftsa);
		giftsb.clear();
		Gift.addGiftList(config.getConfigurationSection("LuckerEggs."), giftsb);
		giftsc.clear();
		Gift.addGiftList(config.getConfigurationSection("LuckerEggs.ϼ"), giftsc);
		
		breaktool[0]=loadBreakTool(config.getConfigurationSection("BreakTool.ƷϺ"));
		breaktool[1]=loadBreakTool(config.getConfigurationSection("BreakTool."));
		breaktool[2]=loadBreakTool(config.getConfigurationSection("BreakTool.ϼ"));
		
		setEnc(breaktool[0],1);
		setEnc(breaktool[1],2);
		setEnc(breaktool[2],3);
	}
	
	public static void setEnc(ItemStack item, int i) {


		item.addUnsafeEnchantment(Enchantment.DURABILITY, i);
		
	}

	private ItemStack loadBreakTool(ConfigurationSection config) {

		try{
			ItemStack breakitem=new ItemStack(config.getInt("id"));
			ItemMeta im=breakitem.getItemMeta();
			im.setDisplayName(config.getString("display"));
			im.setLore(config.getStringList("lores"));
			breakitem.setItemMeta(im);
			return breakitem;
		}catch(Exception e){
			return null;
		}
		
		
	}

	public static void luck(int i, Player p){
		if(i>=0 && i<27){
			//A
			int index=LotteryUtil.lottery(giftsa);
			if(index!=-1){
				giveReward(p, giftsa.get(index));
			}
			
			
		}else if(i>=27 && i<53){
			//B
			int index=LotteryUtil.lottery(giftsb);
			if(index!=-1){
				giveReward(p, giftsb.get(index));
			}
		}else if(i==53){
			//C
			int index=LotteryUtil.lottery(giftsc);
			if(index!=-1){
				giveReward(p, giftsc.get(index));
			}
		}
	}
	
	
	private static void giveReward(Player p, Gift gift) {

		if(gift.award.isEmpty()){
			return;
		}
		Random r=new Random();
		
		String cmd=gift.award.get(r.nextInt(gift.award.size()));
		cmd=cmd.replace("%p", p.getName());
		
		
		Bukkit.dispatchCommand(Bukkit.getConsoleSender(), cmd);
		p.sendMessage("a c"+gift.typename+" a");
		if(gift.id>1){
			String mess=config.getString("Mess");
			mess=mess
			.replace("&", "")
			.replace("%p", p.getName())
			.replace("%e", gift.eggname)
			.replace("%t", gift.typename);
			p.getServer().broadcastMessage(mess);
		}
		
	}

	public static boolean useBreakTool(int i, Player p){
		
		if(i>=0 && i<27){
			//A
			return useKeyItem(p, Luck.breaktool[0]);
			
		}else if(i>=27 && i<53){
			//B
			return useKeyItem(p, Luck.breaktool[1]);
			
		}else if(i==53){
			//C
			return useKeyItem(p, Luck.breaktool[2]);
			
		}
		
		return false;
	}

	private static boolean useKeyItem(Player p, ItemStack bitem) {

		PlayerInventory inv=p.getInventory();
		int i=0;
		for(ItemStack item:inv.getContents()){
			if(item!=null && item.getType()!= Material.AIR){
				if(item.hasItemMeta()){
					if(item.hasItemMeta()){
						if(item.getItemMeta().equals(bitem.getItemMeta())){
							int amount=item.getAmount();
							amount=amount-1;
							if(amount<1){
								inv.setItem(i, null);
							}else{
								item.setAmount(amount);
							}
							return true;
						}
					}

				}
			}
			i++;
		}
		
		return false;
	}
	
	

}
